"""
try:
    import psyco
    psyco.full()
    print 'psyco installed'
except: 
    print 'psyco not installed'
"""

import os

import pygame
from pygame.locals import *

from pgu import engine, timer, fonts

import intro

SW,SH = 640,480
FPS = 40

class _sound:
    def play(self,n=0):
        pass

class Game(engine.Game):
    def __init__(self):
        pygame.display.init()
        pygame.display.set_icon(pygame.image.load("icon.tga"))
        pygame.display.set_caption("The Hairy Chestival")
   
        self.screen = pygame.display.set_mode((SW,SH),SWSURFACE|FULLSCREEN)
        pygame.mouse.set_visible(0)
        pygame.time.wait(1000) #HACK: let the screen get loaded...
        
        self.timer = timer.Timer(FPS)
        
        
        pygame.font.init()
        #self.font = pygame.font.Font(os.path.join("data","fonts","edmunds.ttf"),30)
        fnt = pygame.font.Font(os.path.join("data","fonts","pupcat__.ttf"),30)
        self.font = fonts.BorderFont(fnt,1,(0,0,0))
        
        fnt = pygame.font.Font(os.path.join("data","fonts","pupcat__.ttf"),40)
        self.font_menu = fonts.BorderFont(fnt,2,(0,0,0))
        
        fnt = pygame.font.Font(os.path.join("data","fonts","edmunds.ttf"),60)
        self.font_title = fonts.BorderFont(fnt,4,(0,0,0))
        
        fnt = pygame.font.Font(os.path.join("data","fonts","pupcat__.ttf"),50)
        self.font_score = fonts.BorderFont(fnt,2,(0,0,0))
        
        try:
            pygame.mixer.init()
            self.audio = 1
        except:
            self.audio = 0
        
        self.sfx = {}
        for name in ['nipple','revup','shavingtime','shaving','upgrade','welcome','yeah']:
            if self.audio:
                self.sfx[name] = pygame.mixer.Sound(os.path.join("data","sfx","%s.wav"%name))
            else: self.sfx[name] = _sound()
            
        self.round = 0
        self.high = 0

        
    def event(self,e):
        if e.type is KEYDOWN and e.key == K_F10:
            pygame.display.toggle_fullscreen()
            return 1
        
    def tick(self):
        self.timer.tick()

game = Game()
#import menu
#game.run(menu.Main(game))
game.run(intro.Main(game))