import os

import pygame
from pygame.locals import *

from pgu import engine, timer, fonts

import menu

FRAMES = [
    (0,1),
    (16+0,2),
    (16+16,3),
    (16+32,4),
    (16+64+0,5),
    (16+64+2,6),
    (16+64+8,7),
    (16+64+12,8),
    (16+64+16,7),
    (16+64+20,8),
    (16+64+24,7),
    (16+64+28,8),
    (16+64+32,6),
    (16+64+48,None),
    ]

class Main(engine.State):
    def __init__(self,game):
        self.game = game
        
    def init(self):
        
        images = {}
        for i in xrange(1,9):
            images[i] = pygame.image.load(os.path.join("data","intro","i%d.jpg"%i)).convert()
        self.images = images
            
        if self.game.audio:
            pygame.mixer.music.load(os.path.join("data","intro","spaceodd.ogg"))
            
            
        
    def paint(self,screen):
        screen.fill((0x45,0x00,0x6d))
        pygame.display.flip()
        
        pygame.time.wait(500) #HACK: let the music load into memory...
        if self.game.audio:
            pygame.mixer.music.set_volume(1.0)
            pygame.mixer.music.play(0)
        self.st = pygame.time.get_ticks()# + 200
        
    def update(self,screen):
        ct = pygame.time.get_ticks()
        t = ct - self.st
        tpf = 1000.0*60.0/140.0
        f = t*4.0/tpf
        
        cur = None
        for fr,img in FRAMES:
            if fr <= f: cur = img
        if cur != None:
            img = self.images[cur]
            screen.blit(img,(120,0))
            pygame.display.flip()
            self.pos = 120
        elif f > 64:
            img = self.images[6]
            self.pos -= 10
            screen.blit(img,(self.pos,0))
            pygame.display.flip()
            if self.pos == -50: return menu.Main(self.game)
        
    def event(self,e):
        if e.type is KEYDOWN and e.key == K_ESCAPE:
            return menu.Main(self.game)
        
        
