import os

import pygame
from pygame.locals import *

from pgu import engine, timer, fonts

import level


class Main(engine.State):
    def __init__(self,game):
        self.game = game
        
    def init(self):
        self.bkgr = pygame.image.load(os.path.join("data","intro","i6.jpg")).convert()
        self.game.sfx['welcome'].play()
        self.game.score = 0
        self.game.round = 0
        if self.game.audio:
            pygame.mixer.music.stop()

    def paint(self,screen):
        screen.fill((0x45,0x00,0x6d))
        screen.blit(self.bkgr,(-50,0))
        
        fnt = self.game.font_title
        
        c = (255,255,255)
        x,y = 210,20
        w = 640-x
        for text in ["The Hairy","Chestival Game"]:
            img = fnt.render(text,1,c)
            screen.blit(img,(x+(w/2-img.get_width()/2),y))
            y+=60
            
        x = 340
        y += 60
        fnt = self.game.font
        for text in ['p - play the game','i - view the intro', 'q - quit','','high: %05d'%(self.game.high)]:
            img = fnt.render(text,1,c)
            screen.blit(img,(x,y))
            y+=40
            
        img = fnt.render('ludum dare #7 entry - (c) 2005 - Phil Hassey',1,c)
        screen.blit(img,(80,440))
        
        pygame.display.flip()
        
    def event(self,e):
        if e.type is KEYDOWN and e.key == K_i:
            import intro
            return intro.Main(self.game)
        if e.type is KEYDOWN and e.key == K_q:
            return engine.Quit(self.game,None)
        if e.type is KEYDOWN and e.key == K_p:
            import level
            return level.Main(self.game)
            
            

        